﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication7
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            comboBox1.Items.Add(new ColorItem(Color.Red, "Červená") { Priority = 1 });
            comboBox1.Items.Add(new ColorItem(Color.Lime, "Zelená") { Priority = 3 });
            comboBox1.Items.Add(new ColorItem(Color.Blue, "Modrá") { Priority = 2 });

            listBox1.Items.Add(new ColorItem(Color.Red, "Červená") { Priority = 1 });
            listBox1.Items.Add(new ColorItem(Color.Lime, "Zelená") { Priority = 3 });
            listBox1.Items.Add(new ColorItem(Color.Blue, "Modrá") { Priority = 2 });
        }

        private void comboBox1_DrawItem(object sender, DrawItemEventArgs e)
        {
            e.DrawBackground();

            if (e.Index < 0)
                return;

            ColorItem item = (ColorItem)comboBox1.Items[e.Index];
            using (Brush b = new SolidBrush(item.Color),
                fontBrush = new SolidBrush(e.ForeColor))
            {
                e.Graphics.FillRectangle(b,
                    e.Bounds.Left + 2,
                    e.Bounds.Top + 2,
                    e.Bounds.Height - 4,
                    e.Bounds.Height - 4);

                e.Graphics.DrawString(item.Text, e.Font, fontBrush,
                    e.Bounds.X + e.Bounds.Height + 4, e.Bounds.Top + 2);
            }

            e.DrawFocusRectangle();
        }

        private void comboBox1_MeasureItem(object sender, MeasureItemEventArgs e)
        {
            if (e.Index < 0)
                return;

            ColorItem item = (ColorItem)comboBox1.Items[e.Index];
            e.ItemHeight = 20 * item.Priority;
            
        }

        private void listBox1_DrawItem(object sender, DrawItemEventArgs e)
        {
            e.DrawBackground();

            if (e.Index < 0)
                return;

            ColorItem item = (ColorItem)comboBox1.Items[e.Index];
            using (Brush b = new SolidBrush(item.Color),
                fontBrush = new SolidBrush(e.ForeColor))
            {
                e.Graphics.FillRectangle(b,
                    e.Bounds.Left + 2,
                    e.Bounds.Top + 2,
                    e.Bounds.Height - 4,
                    e.Bounds.Height - 4);

                e.Graphics.DrawString(item.Text, e.Font, fontBrush,
                    e.Bounds.X + e.Bounds.Height + 4, e.Bounds.Top + 2);
            }

            e.DrawFocusRectangle();
        }
    }

    public class ColorItem
    {
        public Color Color { get; set; }

        public string Text { get; set; }

        public int Priority { get; set; }

        public ColorItem(Color color, string text)
        {
            this.Text = text;
            this.Color = color;
        }
    }
}
